Subject: [urn] 2141bis: abstract and intro

From: Peter Saint-Andre <[email-masked]>
Date: Mon, 10 Jun 2013 22:16:19 -0600

While reading RFC 3986 and RFC 3305 recently, I noticed that RFC 2141
contains some archaic language, which 2141bis inherits. Therefore I
propose the following changes...

OLD
   A Uniform Resource Name (URN) is a Uniform Resource Identifier (URI)
   that is intended to serve as a persistent, location-independent
   resource identifier.  The general class of URNs is differentiated
   from all other URIs through the use of the 'urn' URI scheme.  This
   document defines the canonical syntax for URNs, guidelines for URN
   namespaces, requirements for URN presentation and transmission, and
   methods for determining URN equivalence.  This document obsoletes RFC
   2141.

NEW
   A Uniform Resource Name (URN) is a Uniform Resource Identifier (URI)
   that is intended to serve as a persistent, location-independent
   resource identifier.  Historically, the term "URN" has referred to
   both URIs under the "urn" scheme and to any other URIs with the
   properties of a name.  This document defines the canonical syntax for
   URIs under the "urn" scheme, guidelines for URN namespaces,
   requirements for URN presentation and transmission, and methods for
   determining URN equivalence.  This document obsoletes RFC 2141.

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/

---

From: Patrik Fältström <[email-masked]>
Date: Tue, 11 Jun 2013 05:56:22 -0400

On 11 jun 2013, at 00:16, Peter Saint-Andre <[email-masked]> wrote:

>    properties of a name.

Hmm...is "name" specific enough here? Should it not be "...and other URIs with the properties of such a URI."

>    This document defines the canonical syntax for

Otherwise fine with me.

   Patrik

---

From: Peter Saint-Andre <[email-masked]>
Date: Tue, 11 Jun 2013 10:28:54 -0600

On 6/11/13 3:56 AM, Patrik Fältström wrote:
>> NEW A Uniform Resource Name (URN) is a Uniform Resource
>> Identifier (URI) that is intended to serve as a persistent, 
>> location-independent resource identifier.  Historically, the
>> term "URN" has referred to both URIs under the "urn" scheme and
>> to any other URIs with the properties of a name.
> 
> Hmm...is "name" specific enough here? Should it not be "...and
> other URIs with the properties of such a URI."

I was trying to capture in a few words the following concept from RFC
3986 (Section 1.1.3):

   The term "Uniform Resource Name"
   (URN) has been used historically to refer to both URIs under the
   "urn" scheme [RFC2141], which are required to remain globally unique
   and persistent even when the resource ceases to exist or becomes
   unavailable, and to any other URI with the properties of a name.

But I didn't succeed. :-) How about this?

   Historically, the term "URN" has referred to URIs that "remain
   globally unique and persistent even when the resource ceases to
   exist or becomes unavailable" [RFC3986], including but not limited
   to URIs under the "urn" scheme.

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/

---

From: Patrik Fältström <[email-masked]>
Date: Tue, 11 Jun 2013 14:17:20 -0400

>    to URIs under the "urn" scheme.

I like this better! :-)

   Patrik

---

From: "Svensson, Lars" <[email-masked]>
Date: Wed, 12 Jun 2013 16:03:43 +0000

> >    to URIs under the "urn" scheme.

Fine with me, too.

Lars

---

From: Keith Moore <[email-masked]>
Date: Wed, 12 Jun 2013 15:02:21 -0400

On 06/11/2013 12:16 AM, Peter Saint-Andre wrote:
> -----BEGIN PGP SIGNED MESSAGE-----
> Hash: SHA1
>

The proposed new text is incorrect.  It is not the case that

Historically, the term "URN" has referred to
    both URIs under the "urn" scheme and to any other URIs with the
    properties of a name.

Keith

---

From: Keith Moore <[email-masked]>
Date: Wed, 12 Jun 2013 15:03:18 -0400

Stop trying to reconcile the errors in 3986.   3986 contains several 
lies and misrepresentations.

Keith

On 06/11/2013 12:28 PM, Peter Saint-Andre wrote:
> -----BEGIN PGP SIGNATURE-----
> Version: GnuPG/MacGPG2 v2.0.19 (Darwin)
> Comment: GPGTools - http://gpgtools.org
> Comment: Using GnuPG with Thunderbird - http://www.enigmail.net/
>
> iQIcBAEBAgAGBQJRt1BGAAoJEOoGpJErxa2pCC8P/iEy/ZrN65faUCvrXCXhD3jb
> ITblxovm1+FEc5G4FE60zoB7OYkgOiLD99mtQVOrQP1EyPcUDyyLTJGbxm/XAxgD
> sYy2yQ4S7SqEBjIrNEFelyFZ6ijToR3OO4wnA+HCjZfk/RH+PXdzFgYA09uRRp92
> TN/5dXTwrlDhfepwmLCQR3m7LyZEOISaFp/qWkD41H0UxOvrEL836hyqgCPtfPtw
> Xr/OKGLQFDR1bz2Tlci9zOJW/qQ9ZbwC+YF4iiKM97SDqxFkaYD++L3c/xegmodB
> BYEC3d6MCkjZWn+okuOaVkqFuspOPVG+fNAU4lLI9HuYAGPlA7z8vmdpQnd4dtCY
> T3ZIflxlnqQHCD+4EJlWGU/bUqUnhFaBwLMU7hmnauZt5zTfdRbKpK3pppGQt+yj
> 5NLhcm+IXA1rn0zeAGrdqwuCDUMmJMNKk3zqv/91ohiL/UsmwHf13sXP0HHaEL+O
> qCho9dk7p3vz/D4X3LVzEaTdfw3oOGy63Cm84T7lrHRVHU3U/gg/M98PkSDiZrs+
> ZdZglKF1s7f9wUKSr5iD+kLVki1+Qpf1GK/YO4+gzqnzjljC5zkQHiY7hkM/8Df5
> Yw8tCIIWBb46lAZYuFvLyVBex03uGq/m44Grd/fbGwEVIKE9XKZGrrqttdwnuYls
> fvxjTx+DKVaSkGUPqt++
> =kq4p
> -----END PGP SIGNATURE-----
> _______________________________________________
> urn mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/urn

---

From: Keith Moore <[email-masked]>
Date: Wed, 12 Jun 2013 15:04:58 -0400

>>     to URIs under the "urn" scheme.

I don't like it at all.   I don't recall a single instance of the term 
"URN" being used in this way.

It's simply false to say that any URI can be a URN as long as the 
binding between the name and the resource is persistent.   An essential 
property of URNs is that the persistence is advertised as part of the name.

Keith

---

From: Peter Saint-Andre <[email-masked]>
Date: Wed, 12 Jun 2013 17:02:56 -0600

On 6/12/13 1:03 PM, Keith Moore wrote:
> Stop trying to reconcile the errors in 3986.   3986 contains
> several lies and misrepresentations.

That is a very strong statement. Unfortunately I don't see the errata
posted at http://www.rfc-editor.org/errata_search.php?rfc=3986 to back
up your claims.

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/

---

From: Peter Saint-Andre <[email-masked]>
Date: Wed, 12 Jun 2013 17:04:03 -0600

On 6/12/13 1:04 PM, Keith Moore wrote:
>>> globally unique and persistent even when the resource ceases
>>> to exist or becomes unavailable" [RFC3986], including but not
>>> limited to URIs under the "urn" scheme.
>> I like this better! :-)
>> 
>> Patrik
> 
> I don't like it at all.   I don't recall a single instance of the
> term "URN" being used in this way.
> 
> binding between the name and the resource is persistent.   An
> essential property of URNs is that the persistence is advertised as
> part of the name.

Clarifying question: do you mean that a URN needs to start with the
"urn" scheme?

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/

---

From: Keith Moore <[email-masked]>
Date: Wed, 12 Jun 2013 22:46:11 -0400

I'm not sure that the errata system even existed until several years after 3986 came out.   But basically there were a set of people who weren't well plugged into IETF who didn't think that URNs should exist, and the text about URNs in 3986 was written to promote that view.  So if you wonder why 3986 is inconsistent with 2141, that's why.  3986 was written in part to try to undermine 2141.

Keith

Sent from my iPhone

On Jun 12, 2013, at 7:02 PM, Peter Saint-Andre <[email-masked]> wrote:

> iQIcBAEBAgAGBQJRuP4fAAoJEOoGpJErxa2pco4QAJ+VMNs5lD+V1pMjUbgD/XL6
> By6v24rZDE0SraaoYSSilsUJEqSSZumzKKqnIfBAb9+2Wwp3J1NJ4exQhU6BaMaa
> rubx97uYQGeY74alQxFfJ/GCU35LWGF2tk/fOot8PClI3cwWSyhvStwHUwo+lnJ2
> 1AjeGQ/OtlnYiK5IBBrVhh4SZYC2rals6Sgdnh9QlzBvuaVcT6jonr9nDhivJsAi
> 1WDO6Yv6EtlhXQjcY5zlc9oISBiGGw3WsN6LcyuZy6zBMmORZ1Fw4aKlSAs96wKG
> NWl2n/er+Lrw+OPJ7HcF+D593MjZGg/UKB+kNGfO+zyjmLWC4oG5Nye4v8MfkOLz
> vjlcM7IrVILMugd9CM+kva4qMk/2+vN19shkvexg3U+BFg50ArH/q1urFWpegs1I
> vNHUD21TH6/pRwfbcyHCxDPKVcwNRuKoQK1gKsdCmE6XsxZdHhZ96i6jYiohGwUx
> E7pVFLdtOzYS9Od13Wspj62W1rlAvTExd9rD81HW8HAaKKOscImVQOIaivv+uxcb
> rlVIYA1+JssWAruTA8mXPVS52u0LnOy31KGfKY9gTrVDF61Iq+1PEMpYnwIcKCxb
> kcbE6DsyWjI6Em2HW145+KR3lnDhSs92e2jL4n8GmjaJ295c0zKg5/o2cVrAJxhD
> ESuWNK/z8t4f9WOLOGwe
> =1Is+

---

From: Julian Reschke <[email-masked]>
Date: Thu, 13 Jun 2013 09:18:05 +0200

On 2013-06-12 21:02, Keith Moore wrote:
> ...
> ...

That has been my understanding of "URN" in the past. I understand you 
disagree, but *my* understanding is based on the specs I read, and 
that's what they've been saying for a long time. YMMV.

Best regards, Julian

---

From: Keith Moore <[email-masked]>
Date: Thu, 13 Jun 2013 09:23:09 -0400

> Clarifying question: do you mean that a URN needs to start with the

Ok, I have heard name spaces like ISBN or OID that are defined in such a 
way as to have the persistent binding property, described as URNs.   I 
always took that as a shorthand for "X is an example of something that 
can be a URN"

However, it's misleading in the extreme to say that a random URL that 
isn't known to be part of such a namespace is, or can be, a URN.   Sure, 
it might happen that that particular URL has a persistent binding to its 
resource, but you have no way of knowing that.

Keith

---

From: Peter Saint-Andre <[email-masked]>
Date: Thu, 13 Jun 2013 09:08:32 -0600

On 6/13/13 7:23 AM, Keith Moore wrote:
>> -----BEGIN PGP SIGNED MESSAGE----- Hash: SHA1
>> 
>>> It's simply false to say that any URI can be a URN as long as
>>> the binding between the name and the resource is persistent.
>>> An essential property of URNs is that the persistence is
>>> advertised as part of the name.
>> Clarifying question: do you mean that a URN needs to start with
>> the "urn" scheme?
> 
> Ok, I have heard name spaces like ISBN or OID that are defined in
> such a way as to have the persistent binding property, described as
> URNs.   I always took that as a shorthand for "X is an example of
> something that can be a URN"
> 
> However, it's misleading in the extreme to say that a random URL
> that isn't known to be part of such a namespace is, or can be, a
> URN.   Sure, it might happen that that particular URL has a
> persistent binding to its resource, but you have no way of knowing
> that.

This is not the URIbis WG, it's the URNbis WG. And I note that RFC
3986 is a full standard. What is the proposed text change for 2141bis?

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/

---

From: Keith Moore <[email-masked]>
Date: Thu, 13 Jun 2013 11:16:50 -0400

On 06/13/2013 11:08 AM, Peter Saint-Andre wrote:
> -
> 3986 is a full standard.

Full standards can be updated by publication of new standards-track RFCs.

> What is the proposed text change for 2141bis?
>
The following text is correct as written and needs no changes:

---

From: Keith Moore <[email-masked]>
Date: Thu, 13 Jun 2013 11:28:02 -0400

>     methods for determining URN equivalence.  This document obsoletes RFC

If I were trying to be diplomatic, I might add something like:

Historically, the term "URN" has sometimes also been used to describe 
URIs that were intended to be persistently associated with the resources 
with which they were initially associated, and this has unfortunately 
caused some confusion.   This document describes specifically URIs that 
begin with the prefix "urn:" and which have the characteristics 
described in this document.   Also, the use of the term URN within this 
document refers specifically to the specific kind of persistent 
identifiers described herein.   Other kinds of persistent identifiers 
are out of scope for this document.

Keith

---

From: Peter Saint-Andre <[email-masked]>
Date: Thu, 13 Jun 2013 09:37:59 -0600

On 6/13/13 9:28 AM, Keith Moore wrote:
>>> - This is not the URIbis WG, it's the URNbis WG. And I note
>>> that RFC 3986 is a full standard.
>> 
>> A Uniform Resource Name (URN) is a Uniform Resource Identifier
>> (URI) that is intended to serve as a persistent,
>> location-independent resource identifier.  The general class of
>> URNs is differentiated from all other URIs through the use of the
>> 'urn' URI scheme. This document defines the canonical syntax for
>> URNs, guidelines for URN namespaces, requirements for URN
>> presentation and transmission, and methods for determining URN
>> equivalence.  This document obsoletes RFC 2141.
>> 
> 
> Historically, the term "URN" has sometimes also been used to
> describe URIs that were intended to be persistently associated with
> the resources with which they were initially associated, and this
> has unfortunately caused some confusion.   This document describes
> specifically URIs that begin with the prefix "urn:" and which have
> the characteristics described in this document.   Also, the use of
> the term URN within this document refers specifically to the
> specific kind of persistent identifiers described herein.   Other
> kinds of persistent identifiers are out of scope for this
> document.

I certainly agree with that last sentence!

So it might be safer to remove generalizations about what is and is
not a URN, and claim only that we are defining the syntax for the
"urn" scheme. I propose the following text (one could quibble over the
word "typically" in the second sentence, but it probably provides some
wiggle room).

1.  Introduction

   A Uniform Resource Name (URN) is a Uniform Resource Identifier (URI)
   [RFC3986] that is intended to serve as a persistent, location-
   independent resource identifier.  Typically, such URIs are minted
   under the "urn" scheme.  This document defines the canonical syntax
   for URIs under the "urn" scheme, guidelines for URN namespaces,
   requirements for URN presentation and transmission, and methods for
   determining URN equivalence.

   URNs were originally defined in [RFC2141].  The goal of this document
   is to specify URNs with the smallest reasonable set of changes from
   the original definition while ensuring consistency with the updated
   specification of URIs in [RFC3986].  If approved, this document will
   obsolete RFC 2141.

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/

---

From: Keith Moore <[email-masked]>
Date: Thu, 13 Jun 2013 11:46:07 -0400

>     specification of URIs in [RFC3986].  If approved, this document will

I really don't like the wiggle room implied by the word "typically".   I 
want to try to reduce the confusion resulting from the variant uses of 
the term URN and in particular the way 3986 uses the term.

Keith

---

From: Peter Saint-Andre <[email-masked]>
Date: Thu, 13 Jun 2013 09:49:23 -0600

On 6/13/13 9:46 AM, Keith Moore wrote:
>>>>> - This is not the URIbis WG, it's the URNbis WG. And I
>>>>> note that RFC 3986 is a full standard.
>>>> A Uniform Resource Name (URN) is a Uniform Resource
>>>> location-independent resource identifier.  The general class
>>>> of URNs is differentiated from all other URIs through the use
>>>> of the 'urn' URI scheme. This document defines the canonical
>>>> syntax for URNs, guidelines for URN namespaces, requirements
>>>> for URN presentation and transmission, and methods for
>>> describe URIs that were intended to be persistently associated
>>> with the resources with which they were initially associated,
>>> and this has unfortunately caused some confusion.   This
>>> document describes specifically URIs that begin with the prefix
>>> "urn:" and which have the characteristics described in this
>>> document.   Also, the use of the term URN within this document
>>> refers specifically to the specific kind of persistent
>>> identifiers described herein.   Other kinds of persistent
>>> identifiers are out of scope for this document.
>> So it might be safer to remove generalizations about what is and
>> is not a URN, and claim only that we are defining the syntax for
>> the "urn" scheme. I propose the following text (one could quibble
>> over the word "typically" in the second sentence, but it probably
>> provides some wiggle room).
>> 
>> 1.  Introduction
>> 
>> (URI) [RFC3986] that is intended to serve as a persistent,
>> location- independent resource identifier.  Typically, such URIs
>> are minted under the "urn" scheme.  This document defines the
>> canonical syntax for URIs under the "urn" scheme, guidelines for
>> URN namespaces, requirements for URN presentation and
>> transmission, and methods for determining URN equivalence.
>> 
>> URNs were originally defined in [RFC2141].  The goal of this
>> document is to specify URNs with the smallest reasonable set of
>> changes from the original definition while ensuring consistency
>> with the updated specification of URIs in [RFC3986].  If
>> approved, this document will obsolete RFC 2141.
>> 
>> 
> 
> I really don't like the wiggle room implied by the word
> "typically".   I want to try to reduce the confusion resulting from
> the variant uses of the term URN and in particular the way 3986
> uses the term.

So you want 2141bis to state that URNs are all and only URIs under the
"urn" scheme. Correct?

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/

---

From: Keith Moore <[email-masked]>
Date: Thu, 13 Jun 2013 12:29:11 -0400

Sent from my iPhone

> So you want 2141bis to state that URNs are all and only URIs under the

I want 2141bis to encourage use of the term URN to mean only URIs that begin with "urn:" and follow the rules in 2141 / 2141bis.   Confusion over the use of the term URN has degraded the utility of URNs, and to the extent possible, I'd like for 2141bis to reverse that tendency.

Now, having said that, I do recognize that for 2141bis to flat out state that 3986 is wrong could be counterproductive.   I think a better approach would be for 2141bis to make a clearer justification for having a type of URI that is distinguished as being persistent (I.e. a URN) than was made in 2141.  Much of the criticism of URNs has come from people who did not understand them.  To some extent this might be because the original documents were not as clear as they might have been.  But now we have an opportunity to fix that.

Keith